Attribute VB_Name = "ParseBNLS"
Public Function Parse(Data As String) As Boolean
Dim PacketID As Integer
Dim packet As String
Dim Result As Integer
Dim PacketData As String
Dim GTC As Long
PacketData = Mid(Data, 4)
PacketID = Asc(Mid(Data, 3))
If PacketScreen = True Then
    If Len(Hex(PacketID)) = 1 Then
        AddC True, Form8.TALK, vbRed, "[BNLS (TCP)]: S => C: 0x0" & Hex(PacketID)
    Else
        AddC True, Form8.TALK, vbRed, "[BNLS (TCP)]: S => C: 0x" & Hex(PacketID)
    End If
End If
Select Case PacketID

Case &HD
    Result = MakeLong(Mid(PacketData, 1, 4))
    RecievedNLSRevision (CBool(Result))

Case &HE
    Dim XL As Long
    XL = MakeLong(Mid(PacketData, 1, 4))
    XL = BNLSChecksum("owner", XL)
    With pbuffer
        .InsertDWORD XL
        .SendBNLSPacket &HF
    End With
    Case &H7
        HashData = Mid(Data, 4)
        With pbuffer
            .InsertNonNTString Mid(Data, 4)
            .SendPacket &H57
        End With
Case &H1
    CDKeyHash = Mid(Data, 12)
    GTC = Val("&H" & StrToHex(StrReverse(Mid(Data, 8, 4))))
    GTC = CLng(GTC)
    AddC True, Form1.TALK, QBColor(8), "Executable information: " & exeinfo
    AddC True, Form4.TALK, QBColor(8), "Executable information: " & exeinfo
    With pbuffer
        .InsertDWORD GTC
        .InsertDWORD version
        .InsertDWORD CheckSum
        .InsertDWORD &H1
        .InsertDWORD &H0
        .InsertNonNTString CDKeyHash
        .InsertNTString exeinfo
        .InsertNTString varUser
        .SendPacket &H51
    End With
    Case &H4
        With pbuffer
            .InsertNonNTString Mid(Data, 4)
            .InsertNTString varUser
            .SendPacket &H52
        End With
    Case &H2
        accounthash = Mid(Data, 4)
        With pbuffer
            .InsertNonNTString Mid(Data, 4)
            .InsertNTString varUser
            .SendPacket &H53
        End With
    Case &H3
        accountHash2 = Mid(Data, 4)
        With pbuffer
            .InsertNonNTString Mid(Data, 4)
            .SendPacket &H54
        End With
    Case &HC
        CDKeyHash = Mid(Data, 18, 36)
        CDKey2hash = Mid(Data, 58, 36)
        GTC = Val("&H" & StrToHex(StrReverse(Mid(Data, 14, 4))))
        GTC = CLng(GTC)
        AddC True, Form1.TALK, QBColor(8), "Executable information: " & exeinfo
        AddC True, Form4.TALK, QBColor(8), "Executable information: " & exeinfo
        With pbuffer
            .InsertDWORD GTC
            .InsertDWORD version
            .InsertDWORD CheckSum
            .InsertDWORD &H2
            .InsertDWORD &H0
            .InsertNonNTString CDKeyHash
            .InsertNonNTString CDKey2hash
            .InsertNTString exeinfo
            .InsertNTString varUser
            .SendPacket &H51
        End With

Case &H10
    'verByte = Hex(GetDWORD(Mid(Data, 8, 4)))
    AddC True, Form1.TALK, vbWhite, "Suggested version byte: " & Hex(GetDWORD(Mid(Data, 8, 4)))
    AddC True, Form4.TALK, vbWhite, "Suggested version byte: " & Hex(GetDWORD(Mid(Data, 8, 4)))
    AddC True, Form4.TALK, QBColor(8), "Connecting to battle.net..."
    AddC True, Form1.TALK, QBColor(8), "Connecting to battle.net..."
    MDIForm1.winsock.Connect VarServer, 6112
Case &H2
   HashData = Mid(PacketData, 1)
   With pbuffer
        .InsertNonNTString HashData
        .InsertNTString varUser
        .SendPacket &H53
   End With
Case &H9
    Result = MakeLong(Mid(PacketData, 1, 4))
    If Result > 0 Then
        version = Val("&H" & StrToHex(StrReverse(Mid(Data, 8, 4))))
        version = CLng(version)
        CheckSum = Val("&H" & StrToHex(StrReverse(Mid(Data, 12, 4))))
        CheckSum = CLng(CheckSum)
        exeinfo = Mid(Data, 16, Len(Data) - 16)
        If VarProduct = "PX2D" Or VarProduct = "PX3W" Then
            With pbuffer
                .InsertDWORD &H0
                .InsertBYTE &H2
                .InsertDWORD &H1
                .InsertDWORD Servers
                .InsertNTString varCDkey
                .InsertNTString varCDkey2
                .SendBNLSPacket &HC
            End With
         Else
            With pbuffer
                .InsertDWORD Servers
                .InsertNTString varCDkey
                .SendBNLSPacket &H1
            End With
        End If
    Else
        AddC True, Form1.TALK, vbRed, "BNLS version check failed."
        AddC True, Form4.TALK, vbRed, "BNLS version check failed."
    End If

Case &HF
    AddC True, Form1.TALK, vbGreen, "Logged on to BNLS."
    AddC True, Form4.TALK, vbGreen, "Logged on to BNLS."
    With pbuffer
        .InsertDWORD GetBNLSProdID(VarProduct)
        .SendBNLSPacket &H10
    End With
    AddC True, Form4.TALK, QBColor(8), "Requesting version byte..."
    AddC True, Form1.TALK, QBColor(8), "Requesting version byte..."
Case Else
    If Len(PacketID) = 1 Then
        AddC True, Form1.TALK, vbWhite, "Unhandled BNLS Packet: 0x0" & Hex(PacketID)
        AddC True, Form4.TALK, vbWhite, "Unhandled BNLS Packet: 0x0" & Hex(PacketID)
    Else
        AddC True, Form1.TALK, vbWhite, "Unhandled BNLS Packet: 0x" & Hex(PacketID)
        AddC True, Form4.TALK, vbWhite, "Unhandled BNLS Packet: 0x" & Hex(PacketID)
    End If
End Select

End Function
Private Sub RecievedNLSRevision(passed As Boolean)
If passed And NLSRevision <> 0 Then
    AddC True, Form1.TALK, vbRed, vbRed, "NLS Revision didn't pass."
    AddC True, Form4.TALK, vbRed, vbRed, "NLS Revision didn't pass."
End If
End Sub
